function [p , i] = gaussian_prob(x, m, C,invC , i ,use_log)
% GAUSSIAN_PROB Evaluate a multivariate Gaussian density.
% p = gaussian_prob(X, m, C)
% p(i) = N(X(:,i), m, C) where C = covariance matrix and each COLUMN of x is a datavector

% p = gaussian_prob(X, m, C, 1) returns log N(X(:,i), m, C) (to prevents underflow).
%
% If X has size dxN, then p has size Nx1, where N = number of examples

if nargin < 4, use_log = 0; end

if length(m)==1 % scalar
  x = x(:)';
end
[d N] = size(x);
%assert(length(m)==d); % slow
m = m(:);
M = m*ones(1,N); % replicate the mean across columns

%yanxin
%n = size(C,1);
%C = C + eye(n) .* (randn(n) * 0.001);
%yanxin
%S = C + rand(size(C,1)) * 0.1;

%[L,U] = lu(C);
temp = abs(det(i*C));
logtemp = 0;
if temp ~= 0
    logtemp = log(temp) - length(C) * log(i);
end

while temp == 0 | isinf(logtemp) 
    if temp == 0
        i = i + 1;
    else
        i= i -1;
    end
    temp = abs(det(i*C));
    if temp ~= 0
        logtemp = log(temp) - length(C) * log(i);
    end
%    fprintf('help = %d ',i);
end

logdenom = (d/2)*log(2*pi) + logtemp / 2;
mahal = sum(((x-M)'*invC).*(x-M)',2);   % Chris Bregler's trick
%if any(mahal<0)
%    warning('mahal < 0 => C is not psd')
%end
if use_log
  p = -0.5*mahal - logdenom;
else
  p = exp(-0.5*mahal) / (denom+eps);
end
